T_FREE(3N)

NAME
t_free - free a library structure

SYNOPSIS

#include <tiuser.h>

int t_free(ptr, struct_type)
char *ptr;
int struct_type;

DESCRIPTION

t_free() frees memory previously allocated by t_alloc(3N). This function will free memory for the specified structure, and will also free memory for buffers referenced by the structure.

ptr points to one of the six structure types described for t_alloc(3N), and struct_type identifies the type of that structure which can be one of the following:
    T_BIND		 struct t_bind
    T_CALL		 struct t_call
    T_OPTMGMT	 struct t_optmgmt
    T_DIS		 struct t_discon
    T_UNITDATA	 struct t_unitdata
    T_UDERROR	 struct t_uderr
    T_INFO		 struct t_info

where each of these structures is used as an argument to one or more transport functions.

t_free() checks the addr, opt, and udata fields of the given structure (as appropriate), and frees the buffers pointed to by the buf field of the netbuf (see intro(3)) structure. The maxlen, len, and buf members of the netbuf structure are described in t_accept(3N). If buf is NULL, t_free() will not attempt to free memory. After all buffers are freed, t_free() will free the memory associated with the structure pointed to by ptr.

Undefined results will occur if ptr or any of the buf pointers points to a block of memory that was not previously allocated by t_alloc(3N).

RETURN VALUES

t_free() returns:

0   on success.

-1  on failure and sets t_errno to indicate the error.

ERRORS

TSYSERR
    The function failed due to a system error and set errno to indicate the error.

SEE ALSO
intro(3), t_alloc(3N)